# Filters

Since widgets provide a visual representation of the data, they also commonly offer a rich interface for filtering: for example, clicking in a specific bar within a bar chart could filter the entire application, or at least, filter data within a map. We'll refer to this type of **non-geospatial filtering as** [**column filters**](#column-filters)**.**

But also, interacting with the map (such as zooming in a specific location, or drawing a circle) could trigger filters that are based on geospatial information, most commonly a specific area. We'll refer to this type of **geospatial (polygon) based filtering as** [**spatial filters**](#spatial-filters).

{% hint style="success" %}
**Depending on the source, filters in CARTO will work server-side or client-side**.

* When working server-side (`...TableSource` and `...QuerySource` sources) all filtering is powered by your cloud data warehouse, allowing for unmatched scalability and performance with perfect precision.
* When working client-side (`...TilesetSource` and `rasterSource` sources) all filtering is applied locally to widgets, allowing for a balance between precision and impressive performance and granularity. Read more about [client-side considerations](/carto-for-developers/reference/carto-widgets-reference/server-side-vs.-client-side.md).

For GPU-powered filtering directly in your CARTO + deck.gl layers, feel free to check the [DataFilterExtension](https://deck.gl/docs/api-reference/extensions/data-filter-extension) in deck.gl.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.carto.com/carto-for-developers/reference/filters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
